class CStats
{
   var mArena;
   var mTime_CollectAllBarrels;
   var mTime_CollectAllStars;
   var mTime_Total;
   var mNumber_TotalStars;
   var mNumber_TotalSpins;
   var mNumber_FastestSpin;
   var mNumber_FastestSpeed;
   var mNumber_TotalDistance;
   var mNumber_HighestJumpVertical;
   var mNumber_HighestJumpHorizontal;
   var mList_AllStars;
   var mList_AllStarsCount;
   var mList_AllArenas;
   var mStartTimer;
   var mCollidePosition;
   function CStats(tArena)
   {
      this.mArena = tArena;
      this.mTime_CollectAllBarrels = 0;
      this.mTime_CollectAllStars = 0;
      this.mTime_Total = 0;
      this.mNumber_TotalStars = 0;
      this.mNumber_TotalSpins = 0;
      this.mNumber_FastestSpin = 0;
      this.mNumber_FastestSpeed = 0;
      this.mNumber_TotalDistance = 0;
      this.mNumber_HighestJumpVertical = 0;
      this.mNumber_HighestJumpHorizontal = 0;
      this.mList_AllStars = new Array();
      this.mList_AllStarsCount = new Array();
      this.mList_AllArenas = [false,false,false,false,false,false,false,false,false,false,false,false];
   }
   function ArenaComplete()
   {
      this.mList_AllArenas[_global.mArenaIndex] = true;
   }
   function CompareAndUpdate(tStats)
   {
      this.mNumber_TotalSpins += tStats.mNumber_TotalSpins / 3.141592653589793 / 2;
      this.mNumber_FastestSpin = this.cau(this.mNumber_FastestSpin,tStats.mNumber_FastestSpin);
      this.mNumber_FastestSpeed = this.cau(this.mNumber_FastestSpeed,tStats.mNumber_FastestSpeed);
      this.mNumber_TotalDistance += tStats.mNumber_TotalDistance;
      this.mNumber_HighestJumpVertical = this.cau(this.mNumber_HighestJumpVertical,tStats.mNumber_HighestJumpVertical);
      this.mNumber_HighestJumpHorizontal = this.cau(this.mNumber_HighestJumpHorizontal,tStats.mNumber_HighestJumpHorizontal);
      var _loc2_ = 1;
      while(_loc2_ <= 5)
      {
         this.mList_AllStarsCount[_loc2_] = tStats.mList_AllStarsCount[_loc2_] == undefined ? this.mList_AllStarsCount[_loc2_] : tStats.mList_AllStarsCount[_loc2_];
         if(tStats.mList_AllStars[_loc2_] != undefined)
         {
            var _loc3_ = 0;
            while(_loc3_ < 100)
            {
               if(tStats.mList_AllStars[_loc2_][_loc3_] != undefined)
               {
                  this.mList_AllStars[_loc2_] = this.mList_AllStars[_loc2_] != undefined ? this.mList_AllStars[_loc2_] : new Array();
                  this.mList_AllStars[_loc2_][_loc3_] = tStats.mList_AllStars[_loc2_][_loc3_];
               }
               _loc3_ = _loc3_ + 1;
            }
         }
         _loc2_ = _loc2_ + 1;
      }
   }
   function Update_FE(mcStats, mcPlay)
   {
      var _loc8_ = 0.00028121484814398203;
      mcStats.mHighestJump = Math.round(this.mNumber_HighestJumpHorizontal);
      mcStats.mFastestSpin = Math.round(this.mNumber_FastestSpin / 6.283185307179586 * 30 * 60);
      var _loc6_ = Math.round(this.mNumber_TotalDistance);
      if(_loc6_ > 1000000000)
      {
         _loc6_ = Math.floor(this.mNumber_TotalDistance / 1000000) + "m";
      }
      else if(_loc6_ > 100000)
      {
         _loc6_ = Math.floor(this.mNumber_TotalDistance / 1000) + "k";
      }
      mcStats.mTotalDistance = _loc6_;
      mcStats.mLongestJump = Math.round(this.mNumber_HighestJumpVertical);
      mcStats.mFastestSpeed = Math.round(this.mNumber_FastestSpeed);
      mcStats.mNumberOfStars = 0;
      var _loc5_ = 0;
      var _loc3_ = 1;
      while(_loc3_ <= 5)
      {
         _loc5_ += this.mList_AllStarsCount[_loc3_] != undefined ? this.mList_AllStarsCount[_loc3_] : 10000;
         if(this.mList_AllStars[_loc3_] != undefined)
         {
            var _loc2_ = 0;
            while(_loc2_ < 100)
            {
               if(this.mList_AllStars[_loc3_][_loc2_] != undefined)
               {
                  mcStats.mNumberOfStars += !this.mList_AllStars[_loc3_][_loc2_] ? 0 : 1;
               }
               _loc2_ = _loc2_ + 1;
            }
         }
         _loc3_ = _loc3_ + 1;
      }
      trace(_loc5_ + "," + mcStats.mNumberOfStars);
      if(_loc5_ == mcStats.mNumberOfStars)
      {
         mcPlay._LockedArena6.gotoAndStop(2);
      }
      mcPlay._Arena1._visible = this.mList_AllArenas[1];
      mcPlay._Arena2._visible = this.mList_AllArenas[2];
      mcPlay._Arena3._visible = this.mList_AllArenas[3];
      mcPlay._Arena4._visible = this.mList_AllArenas[4];
      mcPlay._Arena5._visible = this.mList_AllArenas[5];
      mcPlay._Arena6._visible = this.mList_AllArenas[6];
   }
   function cau(n1, n2)
   {
      return n1 <= n2 ? n2 : n1;
   }
   function CollectStar(tIndex, tAmount)
   {
      this.mList_AllStars[_global.mArenaIndex] = this.mList_AllStars[_global.mArenaIndex] != undefined ? this.mList_AllStars[_global.mArenaIndex] : new Array();
      this.mList_AllStars[_global.mArenaIndex][tIndex] = true;
      this.mList_AllStarsCount[_global.mArenaIndex] = tAmount;
   }
   function Update()
   {
      if(this.mArena == undefined)
      {
         return undefined;
      }
      var _loc2_ = this.mArena.mWheel;
      if(this.mStartTimer == undefined && this.mArena.mState == "play")
      {
         this.mStartTimer = getTimer();
      }
      this.mNumber_FastestSpeed = _loc2_.mDelta.length <= this.mNumber_FastestSpeed ? this.mNumber_FastestSpeed : _loc2_.mDelta.length;
      this.mNumber_FastestSpin = _loc2_.mAngularVelocity <= this.mNumber_FastestSpin ? this.mNumber_FastestSpin : _loc2_.mAngularVelocity;
      this.mNumber_TotalSpins = this.mNumber_TotalSpins != undefined ? this.mNumber_TotalSpins + Math.abs(_loc2_.mAngularVelocity) : Math.abs(_loc2_.mAngularVelocity);
      this.mNumber_TotalDistance = this.mNumber_TotalDistance != undefined ? this.mNumber_TotalDistance + _loc2_.mDelta.length : _loc2_.mDelta.length;
      if(_loc2_.mCollide == true)
      {
         this.mCollidePosition = _loc2_.mPosition.clone();
      }
      if(this.mCollidePosition != undefined)
      {
         this.mNumber_HighestJumpVertical = this.mCollidePosition.y - _loc2_.mPosition.y <= this.mNumber_HighestJumpVertical ? this.mNumber_HighestJumpVertical : this.mCollidePosition.y - _loc2_.mPosition.y;
         this.mNumber_HighestJumpHorizontal = Math.abs(this.mCollidePosition.x - _loc2_.mPosition.x) <= this.mNumber_HighestJumpHorizontal ? this.mNumber_HighestJumpHorizontal : Math.abs(this.mCollidePosition.x - _loc2_.mPosition.x);
      }
      this.mTime_CollectAllBarrels = !(this.mTime_CollectAllBarrels == undefined && this.mArena.mMap.mBarrelCount == 0) ? this.mTime_CollectAllBarrels : getTimer() - this.mStartTimer;
      this.mTime_CollectAllStars = !(this.mTime_CollectAllStars == undefined && this.mArena.mMap.mStarCount == 0) ? this.mTime_CollectAllStars : getTimer() - this.mStartTimer;
      this.mTime_Total = !(this.mTime_Total == undefined && this.mArena.mMap.mExited == 0) ? this.mTime_Total : getTimer() - this.mStartTimer;
   }
}
