class scidd.Math.CMath
{
   var _CLASSID_ = "scidd.Math.CMath";
   function CMath()
   {
   }
   static function Range(tNumber, tMin, tMax)
   {
      return tNumber <= tMax ? (tNumber >= tMin ? tNumber : tMin) : tMax;
   }
   static function Never0(tNumber)
   {
      return tNumber != 0 ? tNumber : 0.000001;
   }
   static function Sign(tNumber)
   {
      return tNumber >= 0 ? (tNumber <= 0 ? 0 : 1) : -1;
   }
   static function Tween(tMin, tMax, tFactor, tEaseIn, pow)
   {
      tEaseIn = tEaseIn != undefined ? tEaseIn : 0;
      if(tEaseIn != 0)
      {
         pow = pow != undefined ? pow : 15;
         tFactor = tEaseIn <= 0 ? Math.pow(tFactor,pow * (- tEaseIn) + 1) : 1 - Math.pow(1 - tFactor,pow * tEaseIn + 1);
      }
      return (tMax - tMin) * tFactor + tMin;
   }
   static function Define(tObject, tDefault)
   {
      return tObject != undefined ? tObject : tDefault;
   }
   static function Round(tNumber, tAmount)
   {
      return Math.round(tNumber / tAmount) * tAmount;
   }
   static function DecimalPlaces(tNumber)
   {
      var _loc2_ = 0;
      while(tNumber % 1 != 0)
      {
         tNumber *= 10;
         _loc2_ = _loc2_ + 1;
      }
      return _loc2_;
   }
   static function GetLineNormal(p1, p2)
   {
      var _loc1_ = new flash.geom.Matrix();
      _loc1_.rotate(-1.5707963267948966);
      var _loc2_ = _loc1_.transformPoint(new flash.geom.Point(p2.x - p1.x,p2.y - p1.y));
      _loc2_.normalize(1);
      return _loc2_;
   }
}
