function Update()
{
   var _loc3_ = getTimer();
   mSampleArray[mSampleIndex] = _loc3_ - mSampleTimeStamp;
   mSampleTimeStamp = _loc3_;
   var _loc1_ = 0;
   var _loc2_ = 0;
   while(_loc1_ < mSampleAmount)
   {
      _loc2_ += mSampleArray[_loc1_];
      _loc1_;
      _loc1_++;
   }
   SetLow(GetFPS(mSampleArray[mSampleIndex]));
   mTEXT_FPS = GetFPS(_loc2_ / mSampleAmount);
   mSampleIndex = ++mSampleIndex % mSampleAmount;
}
function GetFPS(tNumber)
{
   var _loc1_ = 1;
   return int(1000 / tNumber * _loc1_) / _loc1_;
}
function SetLow(tNumber)
{
   if(tNumber < mLowFPS || getTimer() - mLowCount >= 2000)
   {
      mLowFPS = tNumber;
      mTEXT_LOW = mLowFPS.toString() + "." + mTEXT_LOW.substring(0,20);
      mLowCount = getTimer();
   }
}
function Profile_Setup()
{
   var _loc1_ = mProfile_List.length - 1;
   while(_loc1_ >= 0)
   {
      mProfile_List[_loc1_].mTotalTime = 0;
      _loc1_ = _loc1_ - 1;
   }
}
function Profile_Start(tID, tRGB)
{
   var _loc1_ = FindID(tID);
   if(_loc1_ == -1)
   {
      _loc1_ = mProfile_List.length;
      mProfile_List[_loc1_] = {mName:tID,mTimeStamp:0,mTotalTime:0,mRGB:tRGB};
   }
   mProfile_List[_loc1_].mTimeStamp = getTimer();
}
function Profile_End(tID)
{
   var _loc2_ = getTimer();
   var _loc1_ = FindID(tID);
   mProfile_List[_loc1_].mTotalTime += _loc2_ - mProfile_List[_loc1_].mTimeStamp;
}
function Profile_Complete()
{
   var _loc7_ = 0;
   var _loc2_ = mProfile_List.length - 1;
   while(_loc2_ >= 0)
   {
      _loc7_ += mProfile_List[_loc2_].mTotalTime;
      _loc2_ = _loc2_ - 1;
   }
   mTEXT_ProfileTime = _loc7_;
   this.clear();
   var _loc3_ = 40;
   var _loc5_ = 24;
   var _loc9_ = 140;
   var _loc10_ = 12;
   var _loc8_ = "";
   _loc2_ = mProfile_List.length - 1;
   while(_loc2_ >= 0)
   {
      var _loc4_ = _loc3_ + mProfile_List[_loc2_].mTotalTime / _loc7_ * _loc9_;
      var _loc6_ = _loc5_ + _loc10_;
      this.beginFill(mProfile_List[_loc2_].mRGB,100);
      this.moveTo(_loc3_,_loc5_);
      this.lineTo(_loc4_,_loc5_);
      this.lineTo(_loc4_,_loc6_);
      this.lineTo(_loc3_,_loc6_);
      this.lineTo(_loc3_,_loc5_);
      this.endFill();
      _loc3_ = _loc4_;
      _loc8_ += Pad(mProfile_List[_loc2_].mName,10) + "\t= " + Pad(mProfile_List[_loc2_].mTotalTime.toString(),4) + "\t(" + Math.round(mProfile_List[_loc2_].mTotalTime / _loc7_ * 100) + "%)" + "\n";
      _loc2_ = _loc2_ - 1;
   }
   mTEXT_Output = _loc8_;
}
function FindID(tID)
{
   var _loc1_ = mProfile_List.length - 1;
   while(_loc1_ >= 0)
   {
      if(mProfile_List[_loc1_].mName == tID)
      {
         return _loc1_;
      }
      _loc1_ = _loc1_ - 1;
   }
   return -1;
}
function Pad(tString, tAmount)
{
   while(tString.length < tAmount)
   {
      tString += " ";
   }
   return tString;
}
var mLowFPS = 0;
var mLowCount = 0;
var mSampleIndex = 0;
var mSampleAmount = 60;
var mSampleArray = new Array(mSampleAmount);
var mSampleTimeStamp = getTimer();
var mSampleTotalTime = 0;
_root.__FPS__ = this;
var mProfile_List = new Array();
